using System;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;

/// @author VESAL
/// @version  29.10.2024
/// <summary>
/// <pre>
/// Aluksi kysyy
///     Anna tulos>?????
///     APINA
///     KISSA
///     KETTU
///     KOIRA
///     ...
///     Anna arvaamasi kirjain>A
///     Anna tulos >A???A
///     APINA
///     Anna arvaamasi kirjain>I
///     Anna tulos >A?I?A
///       
/// </pre>
/// </summary>
public class Hirsiauta
{
    /// <summary>
    /// 
    /// </summary>
    public static void Main(string[] args)
    {
        string nimi = "sanat.txt";
        if (args.Length > 0) nimi = args[0];
        string[] sanat = File.ReadAllLines(nimi);
        string kelpaavat = ".";
        StringBuilder kaytetyt = new StringBuilder();

        while (true)
        {
            Console.Write($"Anna tulos )>");
            string t = Console.ReadLine();
            if (t == null || t == "!") break;
            string maski = t.Replace("?", kelpaavat);

            Regex regex = new Regex("^" + maski + "$", RegexOptions.Compiled | RegexOptions.IgnoreCase);

            foreach (string rivi in sanat) // tutkitaan mitkä rivit täsmäävät
            {
                Match match = regex.Match(rivi);
                if (match.Success)
                {
                    Console.WriteLine(rivi);
                }
            }
            
            Console.Write("Anna arvaamasi kirjain>");
            string kirjain = Console.ReadLine() ?? "";
            kirjain = kirjain.ToUpper();
            kaytetyt.Append(kirjain);
            kelpaavat = "[^" + kaytetyt + "]";   // [^AS]
        }
    }
}